////////////////////////////////////////////////////////////////////////////////
// MAIN.C - BB20dump - Simple BB20 program transfering utility
////////////////////////////////////////////////////////////////////////////////
#include <pager.h>
#include <ribbon.h>
#include "icon.h"
#include "prgs.h" // BB20 programs

char VersionPtr[] = "BB20dump";
int AppStackSize = 1024;

void BB20dumpThread(void)
{
  char i, b[64];
  HandleType H; FileType F;
  PID pid;
  pid.Name = VersionPtr;
  pid.EnableForeground = TRUE;
  pid.Icon = NULL;
  RimSetPID(&pid);
  RimRequestForeground(RimGetCurrentTaskID());
  LcdCopyBitmapToDisplay(&IconBMP, 0, 0); // Show icon bmp
  LcdPutStringXY(18,8,"Dumping programs...", -1, 0);

  for (i=0; i<7; i++) { // <<< NUMBER OF FILES DUMPED
    RimSprintf(b,64,"%d> %s",i+1,name[i]);
    LcdPutStringXY(0,16+i*8,b, -1, 0);
    RimTaskYield();
    H=DbGetHandle(name[i]); F=DbFileOpen(H,256);
    DbFileWrite(F,prg[i],plen[i]);
    DbFileClose(F,TRUE);
  }
  LcdPutStringXY(0,152,"...Transfer complete!", -1, 0);
  RimSpeakerBeep(440,50,50,33); 
  RimSleep(200);
  RibbonShowRibbon();
  RimTerminateThread();
}

void PagerMain(void)
{
  RibbonRegisterFunction(VersionPtr,&IconBMP,0,40,BB20dumpThread,AppStackSize);
}
